/*
 * Revision 0.2  24 Nov 2000 Lou
 * Revision 2.0  27 Nov 2002 Julien BLACHE <jb@jblache.org>
 *
 * $Id: wmbatppc.h 21 2003-07-23 14:34:12Z julien $
 */


#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <dirent.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>
#include <math.h>
#include <limits.h>
#include <errno.h>
#include <signal.h>

#include <sys/wait.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/socket.h>

#include <netinet/in.h> /* INET sockets */
#include <sys/un.h> /* UNIX domain sockets */
#include <netdb.h>

#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <X11/extensions/shape.h>

#define WMBATPPC_VERSION "2.3"

#define LEFT_BATTERY 0
#define RIGHT_BATTERY 1

#define HIGH_BATT 0  // color green
#define LOW_BATT 1  // color red
#define MED_BATT 2  // color yellow

#define NO_BATT 3
#define IS_BATT 4

#define NOCHARGE 0
#define CHARGE 1
#define UNPLUGGED 0
#define PLUGGED 1

#define LIMITED 0
#define INFINITE 1

#define SMALL 0
#define BIG 1

#define HOURS 0
#define MINUTES 1

#define V 0
#define MV 1

#define COMMA 0
#define PERCENT 1

#define WMAKER 10
#define XIMIAN 20

#define PMU_VERSION_KEYLARGO	12

#define PMU_CONFIG_KEYWORD "pmu"
#define PMU_STYLE_NAME "pmu"

#define PMU_PROC_INFO "/proc/pmu/info"
#define PMU_PROC_BATTERY_BASE "/proc/pmu/battery_"
#define PMU_PROC_PRESENT    (1 << 0)
#define PMU_PROC_CHARGING   (1 << 1)

#define PMUD_INPUT_DELIM " \t\n{}" 

#define PMUD_HOST "localhost"
#define PMUD_PORT 879
#define PMUD_SERVICE		"pmud"
#define PMUD_SOCKET_PATH "/etc/power/control"

//#define PMUD_REFRESH

// Colors for TTY output
#define BWHITE "\e[1;37m"
#define BRED "\e[1;31m"
#define BYELLOW "\e[1;33m"
#define BGREEN "\e[1;32m"
#define BRESET "\e[0m"

typedef struct {
	int available;
     	int current;
     	int percentage;
     	int charging;
     	int voltage;
} battery ;

typedef struct {
	int pmud_version ;
	battery b [2] ;
	int batt_state [2] ;
	int time_left ;
	int ac_connected ;
	int show_charge_time ;
	int current ;
} pmud_info ;

typedef struct {
	int x ;
	int y ;
} coords ;

typedef struct {
	coords plug ;
	coords charg ;
	coords timeleft[2] ;
	coords voltage[2] ;
	coords batt[2] ;
	coords percent[2] ;
	coords jukeBox[2] ;
	coords symbols[2] ;
} interface ;

void usage(void);
void printversion(void);
void BlitString(char *name, int x, int y, int is_big);
void BlitNum(int num, int x, int y, int is_big, int two_digits);
void wmbatppc_routine(int, char **);


